﻿include("objects/DpXMLDomDocument.js");
include("objects/DpGetDat.js");
include("servis/format.js")
include("sys/udfs.js");

function Load()
{
	var sDir = getPar("EXPDIR")
	if (!sDir) 
	{
		alert("Установите директорию экспорта");
		return false;		
	}
	
	if (GetMenuMode() == "NDS_DODATOK5")
		ExportDodatok5();
	else if (GetMenuMode() == "NDS_DODATOK8")
		ExportDodatok8();
	else if (GetMenuMode() == "NDS_REESTR")
		ExportReestr();
	else if (GetMenuMode() == "NDS_REESTR_NK")
		ExportReestrNalKredit();
	else if (GetMenuMode() == "NDS_CORRECT")
		ExportCorrect();
	else if (GetMenuMode() == "RRO_CASS")
		ExportRRO();
	else if (GetMenuMode() == "STAT_1PV")
		ExportStat1PV();
	
	CLEARWAIT();	
	return;	
}

function ExportDodatok5()
{
	var gd = new DpGetDat("d");
	if (gd.escape != false)
		return;

	var xml = new DpXMLDOMDocument();
	with(xml)
	{
		with( createChild("DECLAR"))
		{
			setAttribute("xmlns:xsi", "http://www.w3.org/2001/XMLSchema-instance");
			setAttribute("xsi:noNamespaceSchemaLocation", "J0215103.xsd");

			with (createChild("DECLARHEAD"))
			{
				createChild("TIN", getPar("OOKPO"));
				createChild("C_DOC", "J02");
				createChild("C_DOC_SUB", "151");
				createChild("C_DOC_VER", "3");
				createChild("C_DOC_TYPE", "0");
				createChild("C_DOC_CNT", "1");
				createChild("C_REG", getOrgVar("C_REG"));
				createChild("C_RAJ", getOrgVar("C_RAJ"));                  //Район
				createChild("PERIOD_MONTH", format("m",gd.dat1))
				createChild("PERIOD_TYPE", "1");
				createChild("PERIOD_YEAR", format("yyyy", gd.dat1))
				createChild("D_FILL", format("ddmmyyyy", new Date()));
				createChild("SOFTWARE", "DPA");
			}
			with (createChild("DECLARBODY"))
			{
				createChild("TIN", getPar("OOKPO"));
				
				var bDbExists = false;
				var bCrExists = false;
				var nRow = 0;
				strName = "DODATOK5_DB";
				if (isOrgVar("MY_PODRS"))
				{
					var my_podr = getOrgVar("MY_PODRS");
					if (my_podr != "")
					{
						DropTable("DODATOK5_DB2");
						ExecuteSQL("SELECT * INTO DODATOK5_DB2 FROM " + strName + " WHERE FORG NOT IN (" + my_podr + ")");
						ExecuteSQL("INSERT INTO DODATOK5_DB2 (FINDNUM, FSUM, FNDS, FPLATNDS) " +
							" SELECT "+sqlTo(getPar("OKODNDS"))+",SUM(FSUM), SUM(FNDS), 0 FROM " + strName + " WHERE FORG IN (" + my_podr + ")");
						strName = "DODATOK5_DB2";
					}
				}
				var tbl = OpenTable("s", "SELECT FINDNUM, SUM(a.FSUM) FSUM, SUM(a.FNDS) FNDS"
						+ " FROM " + strName + " a"
						+ " WHERE FPLATNDS = " + sqlTrue + " AND (FSUM<>0 or FNDS<>0)"
						+ " GROUP BY FINDNUM"
						+ " HAVING SUM(a.FSUM)<>0"
						);
				if (tbl)
				{
					for (; !tbl.IsEOF(); tbl.MoveNext())
					{
						bDbExists = true;
						nRow++;

						var aAttrRow = {"ROWNUM": nRow};

						createChild("T1RXXXXG2", tbl.getValue("FINDNUM"), aAttrRow);
						createChild("T1RXXXXG3", format("0.00", tbl.getValue("FSUM")), aAttrRow);
						createChild("T1RXXXXG4", format("0.00", tbl.getValue("FNDS")), aAttrRow);
					}
				}
				// Не-плательщиков НДС объединяем в одну строку
				var tbl = OpenTable("s", "SELECT SUM(FSUM) as SUMMA, SUM(FNDS) as NDS FROM " + strName + " WHERE (FPLATNDS is null or FPLATNDS = " + sqlFalse + ") HAVING SUM(FSUM)<>0 or SUM(FNDS)<>0");
				if (tbl && !tbl.IsEOF())
				{
					bDbExists = true;
					createChild("R001G3", format("0.00", tbl.getValue("SUMMA")));
					createChild("R001G4", format("0.00", tbl.getValue("NDS")));
				}

				var nRow = 0;
				strName = "DODATOK5_CR";
				if (isOrgVar("MY_PODRS"))
				{
					var my_podr = getOrgVar("MY_PODRS");
					if (my_podr != "")
					{
						DropTable("DODATOK5_CR2_MY_PODRS");
						ExecuteSQL("SELECT * INTO DODATOK5_CR2_MY_PODRS FROM " + strName + " WHERE FORG NOT IN (" + my_podr + ")");
						ExecuteSQL("INSERT INTO DODATOK5_CR2_MY_PODRS (FINDNUM, FSUM, FNDS) " +
							" SELECT "+sqlTo(getPar("OKODNDS"))+",SUM(FSUM), SUM(FNDS) FROM " + strName + " WHERE FORG IN (" + my_podr + ")");
						strName = "DODATOK5_CR2_MY_PODRS";
					}
				}
				var tbl = OpenTable("s", "SELECT * FROM " + strName + " WHERE FSUM<>0 or FNDS<>0");
				//var tbl = OpenTable("s", "SELECT FINDNUM, MIN(FDATE) as fgdate, SUM(FSUM) as FGSUM, SUM(FNDS) as FGNDS FROM " + strName + " WHERE FSUM<>0 or FNDS<>0"
				// + " GROUP BY FINDNUM, " + sqlYear("FDATE") + ", " + sqlMonth("FDATE") );
				if (tbl)
				{
					for (; !tbl.IsEOF(); tbl.MoveNext())
					{
						bCrExists = true;
						nRow++;

						var aAttrRow = {"ROWNUM": nRow};

						createChild("T2RXXXXG2", tbl.getValue("FINDNUM"), aAttrRow);
						createChild("T2RXXXXG3A", format("mm", tbl.getValue("FDATE")), aAttrRow);
						createChild("T2RXXXXG3B", format("yyyy", tbl.getValue("FDATE")), aAttrRow);
						createChild("T2RXXXXG4", format("0.00", tbl.getValue("FSUM")), aAttrRow);
						createChild("T2RXXXXG5", format("0.00", tbl.getValue("FNDS")), aAttrRow);
					}
				}
				
				
				strName = "DODATOK5_CR2";
				if (IsTable(strName))
				{
					var tbl = OpenTable("s", "SELECT * FROM " + strName + " WHERE FSUM>0 and FNDS>0");
					if (tbl)
					{
						for (; !tbl.IsEOF(); tbl.MoveNext())
						{
							bCrExists = true;
							nRow++;
	
							var aAttrRow = {"ROWNUM": nRow};
	
							createChild("T3RXXXXG2", tbl.getValue("FINDNUM"), aAttrRow);
							createChild("T3RXXXXG3A", format("mm", tbl.getValue("FDATE")), aAttrRow);
							createChild("T3RXXXXG3B", format("yyyy", tbl.getValue("FDATE")), aAttrRow);
							createChild("T3RXXXXG4", format("0.00",tbl.getValue("FSUM")), aAttrRow);
							createChild("T3RXXXXG5", format("0.00",tbl.getValue("FNDS")), aAttrRow);
						}
					}
				}
				
				if (bDbExists == false && bCrExists == false)
					alert("Нет данных для выгрузки в XML");
				else if (bDbExists == false)
					alert("Нет данных по налоговым обязательствам для выгрузки в XML");
				else if (bCrExists == false)
					alert("Нет данных по налоговому кредиту для выгрузки в XML");
			}
		}
	}

	var xmlName = getPar("EXPDIR");
	xmlName += (getPar("EXPDIR").right(1) == "\\" || getPar("EXPDIR").right(1) == "/" ? "" : "\\");
	xmlName += "dodatok5.xml";
	xml.save(xmlName);
	alert("Выгрузка окончена - " + xmlName);
}

function ExportDodatok8()
{
	var gd = new DpGetDat("d");
	if (gd.escape != false)
		return;

	var xml = new DpXMLDOMDocument();
	with(xml)
	{
		with( createChild("DECLAR"))
		{
			setAttribute("xmlns:xsi", "http://www.w3.org/2001/XMLSchema-instance");
			setAttribute("xsi:noNamespaceSchemaLocation", "J0215802.xsd");

			with (createChild("DECLARHEAD"))
			{
				createChild("TIN", getPar("OOKPO"));
				createChild("C_DOC", "J02");
				createChild("C_DOC_SUB", "158");
				createChild("C_DOC_VER", "2");
				createChild("C_DOC_TYPE", "0");
				createChild("C_DOC_CNT", "1");
				createChild("C_REG", "10");
				createChild("C_RAJ", "1");                  //Район
				createChild("PERIOD_MONTH", format("m",gd.dat1))
				createChild("PERIOD_TYPE", "1");
				createChild("PERIOD_YEAR", format("yyyy", gd.dat1))
				createChild("D_FILL", format("ddmmyyyy", new Date()));
				createChild("SOFTWARE", "DPA");
			}
			with (createChild("DECLARBODY"))
			{
				createChild("TIN", getPar("OOKPO"));

				var nRow = 0;
				var arrDodatok8 = importDodatok8Table();
				for(var i = 0; i < arrDodatok8.length; i++)
				{
					nRow++;

					var aAttrRow = {"ROWNUM": nRow};

					createChild("T2RXXXXG2S", arrDodatok8[i]["FTXT"], aAttrRow);
					createChild("T2RXXXXG3", arrDodatok8[i]["FINDNUM"], aAttrRow);
					createChild("T2RXXXXG4D", format("ddmmyyyy", arrDodatok8[i]["FDAT"]), aAttrRow);
					createChild("T2RXXXXG5S", arrDodatok8[i]["FNUM"], aAttrRow);
					createChild("T2RXXXXG6", round(arrDodatok8[i]["FSUM"], 2), aAttrRow);
					createChild("T2RXXXXG7", round(arrDodatok8[i]["FNDS"], 2), aAttrRow);
					createChild("T2RXXXXG8S", "те саме", aAttrRow);
				}
				
				alert("Кол-во записей - " + arrDodatok8.length);
			}
		}
	}

	var xmlName = getPar("EXPDIR");
	xmlName += (getPar("EXPDIR").right(1) == "\\" || getPar("EXPDIR").right(1) == "/" ? "" : "\\");
	xmlName += "dodatok8.xml";
	xml.save(xmlName);
	alert("Выгрузка окончена - " + xmlName);
}


function ExportCorrect()
{
	var gd = new DpGetDat("d");
	if (gd.escape != false)
		return;

	var xml = new DpXMLDOMDocument();
	with(xml)
	{
		with( createChild("DECLAR"))
		{
			setAttribute("xmlns:xsi", "http://www.w3.org/2001/XMLSchema-instance");
			setAttribute("xsi:noNamespaceSchemaLocation", "J0200509.xsd");

			with (createChild("DECLARHEAD"))
			{
				createChild("TIN", getPar("OOKPO"));
				createChild("C_DOC", "J02");
				createChild("C_DOC_SUB", "005");
				createChild("C_DOC_VER", "9");
				createChild("C_DOC_TYPE", "0");
				createChild("C_DOC_CNT", "1");
				createChild("C_REG", "10");
				createChild("C_RAJ", "1");                  //Район
				createChild("PERIOD_MONTH", format("m",gd.dat1))
				createChild("PERIOD_TYPE", "1");
				createChild("PERIOD_YEAR", format("yyyy", gd.dat1))
				createChild("D_FILL", format("ddmmyyyy", new Date()));
				createChild("SOFTWARE", "DPA");
			}
			with (createChild("DECLARBODY"))
			{
				createChild("TIN", getPar("OOKPO"));
				
				var nRow = 0;
				strName = "NDS_CORRECT";
				var tbl = OpenTable("s", "SELECT * FROM " + strName + " WHERE FNDS1<>0 or FNDS2<>0");
				if (!tbl)
				{
					alert("Нет данных для выгрузки в XML");
					return;
				}
				
				for (; !tbl.IsEOF(); tbl.MoveNext())
				{
					nRow++;

					var aAttrRow = {"ROWNUM": nRow};


					createChild("T1RXXXXG2S", tbl.getValue("FNAZV"), aAttrRow);
					createChild("T1RXXXXG3", tbl.getValue("FINDNUM"), aAttrRow);
					createChild("T1RXXXXG4D", format("ddmmyyyy", tbl.getValue("FDATE")), aAttrRow);
					createChild("T1RXXXXG5S", tbl.getValue("FNUM"), aAttrRow);
					createChild("T1RXXXXG6S", tbl.getValue("FDOC_NUM"), aAttrRow);
					createChild("T1RXXXXG7D", format("ddmmyyyy", tbl.getValue("FDOC_DAT")), aAttrRow);
					createChild("T1RXXXXG8S", tbl.getValue("FTXT"), aAttrRow);
					createChild("T1RXXXXG9", format('0.00', tbl.getValue("FNDS2")*5), aAttrRow);
					createChild("T1RXXXXG10", format('0.00', tbl.getValue("FNDS2")), aAttrRow);
					
/*
					createChild("T2RXXXXG2S", tbl.getValue("FNAZV"), aAttrRow);
					createChild("T2RXXXXG3S", tbl.getValue("FINDNUM"), aAttrRow);
					createChild("T2RXXXXG4D", format("ddmmyyyy", tbl.getValue("FDATE")), aAttrRow);
					createChild("T2RXXXXG5S", tbl.getValue("FNUM"), aAttrRow);
					createChild("T2RXXXXG6S", tbl.getValue("FDOC_NUM"), aAttrRow);
					createChild("T2RXXXXG7D", format("ddmmyyyy", tbl.getValue("FDOC_DAT")), aAttrRow);
					createChild("T2RXXXXG8S", tbl.getValue("FTXT"), aAttrRow);
					createChild("T2RXXXXG9_1", tbl.getValue("FNDS2")*5, aAttrRow);
					createChild("T2RXXXXG9", tbl.getValue("FNDS2"), aAttrRow);
*/
				}
			}
		}
	}

	var xmlName = getPar("EXPDIR");
	xmlName += (getPar("EXPDIR").right(1) == "\\" || getPar("EXPDIR").right(1) == "/" ? "" : "\\");
	xmlName += "NDS_correct.xml";
	xml.save(xmlName, "windows-1251");
	alert("Выгрузка окончена - " + xmlName);
}

function ExportRRO()
{
	var gd=new DpGetDat(new Array("r"));
	if (gd.escape != false)
		return;

	if(confirm("Выгрузить отчет для всех РРО?"))
	{
		DropTable("RRO_CASS");	
		ExecuteSQL("SELECT '                                                                                 ' as RXXXXG2S, '                                                                          ' as RXXXXG3S, a.FCAS_COD, "
			+ " sum(a.FSUM_VITORG) RXXXXG4, sum(a.FSUM_VITORG) as RXXXXG5, sum(a.FSUM_VITORG)/6 as RXXXXG6, sum(a.FSUM_V2POK) as RXXXXG7 "
			+ " INTO RRO_CASS FROM ^RBRNK a "
			+ " left join ^HBRNK b on a.fid_doc = b.fwid WHERE FTT=0 AND "
				+ " a.FDATE BETWEEN " + sqlTo(gd.dat1)+" AND "+sqlTo(gd.dat2)
			+ " GROUP BY b.fpodr, a.FCAS_COD"
			+ " ORDER BY b.fpodr, a.FCAS_COD")
		ExecuteSQL("ALTER TABLE RRO_CASS ADD FWID "+ SqlType("COUNTER"));
	}

	var tbl = OpenTable("SELECT * FROM RRO_CASS");
	for (tbl.MoveFirst();!tbl.isEOF();tbl.MoveNext())
	{
		tbl.Edit();
		tbl.setValue("RXXXXG2S", String(xcl(252, Number(tbl.getValue("FCAS_COD")), "RRO_MOD"  )));
		tbl.setValue("RXXXXG3S", String(xcl(252, Number(tbl.getValue("FCAS_COD")), "RRO_N"  )));
		tbl.Update();
	}

	var xml = new DpXMLDOMDocument();
	with(xml)
	{
		with( createChild("DECLAR"))
		{
			setAttribute("xmlns:xsi", "http://www.w3.org/2001/XMLSchema-instance");
			setAttribute("xsi:noNamespaceSchemaLocation", "J0500202.xsd");

			with (createChild("DECLARHEAD"))
			{
				createChild("TIN", getPar("OOKPO"));
				createChild("C_DOC", "J05");
				createChild("C_DOC_SUB", "002");
				createChild("C_DOC_VER", "2");
				createChild("C_DOC_TYPE", "0");
				createChild("C_DOC_CNT", "1");
				createChild("C_REG", "23");
				createChild("C_RAJ", "1");                  //Район
				createChild("PERIOD_MONTH", format("m",gd.dat1))
				createChild("PERIOD_TYPE", "1");
				createChild("PERIOD_YEAR", format("yyyy", gd.dat1))
				createChild("D_FILL", format("ddmmyyyy", new Date()));
				createChild("SOFTWARE", "DPA");
			}
			with (createChild("DECLARBODY"))
			{
				createChild("HTIN", getPar("OOKPO"));
				createChild("HNAME", getPar("OFIRM"));
				var nRow = 0;
				strName = "RRO_CASS";
				var tbl = OpenTable("s", "SELECT * FROM " + strName);
				if (!tbl)
				{
					alert("Нет данных для выгрузки в XML");
					return;
				}
				
				for (; !tbl.IsEOF(); tbl.MoveNext())
				{
					nRow++;

					var aAttrRow = {"ROWNUM": nRow};
					createChild("RXXXXG2S", tbl.getValue("RXXXXG2S"), aAttrRow);
					createChild("RXXXXG3S", tbl.getValue("RXXXXG3S"), aAttrRow);
					createChild("RXXXXG4", tbl.getValue("RXXXXG4"), aAttrRow);
					createChild("RXXXXG5", tbl.getValue("RXXXXG5"), aAttrRow);
					createChild("RXXXXG6", tbl.getValue("RXXXXG6"), aAttrRow);
					createChild("RXXXXG7", tbl.getValue("RXXXXG7"), aAttrRow);
				}
			}
		}
	}

	var xmlName = getPar("EXPDIR");
	xmlName += (getPar("EXPDIR").right(1) == "\\" || getPar("EXPDIR").right(1) == "/" ? "" : "\\");
	xmlName += "RRO_CASS.xml";
	xml.save(xmlName, "windows-1251");
	alert("Выгрузка окончена - " + xmlName);
}

function ExportReestr()
{
	var gd = new DpGetDat("d");
	if (gd.escape != false)
		return;

	var xml = new DpXMLDOMDocument();
	with(xml)
	{
		with( createChild("DECLAR"))
		{
			setAttribute("xmlns:xsi", "http://www.w3.org/2001/XMLSchema-instance");
			setAttribute("xsi:noNamespaceSchemaLocation", "J1201505.xsd");

			with (createChild("DECLARHEAD"))
			{
				createChild("TIN", getPar("OOKPO"));
				createChild("C_DOC", "J12");
				createChild("C_DOC_SUB", "015");
				createChild("C_DOC_VER", "5");
				createChild("C_DOC_TYPE", "0");
				createChild("C_DOC_CNT", "1");
				createChild("C_REG", getOrgVar("C_REG"));
				createChild("C_RAJ", getOrgVar("C_RAJ"));                  //Район
				createChild("PERIOD_MONTH", format("m",gd.dat1))
				createChild("PERIOD_TYPE", "1");
				createChild("PERIOD_YEAR", format("yyyy", gd.dat1))
				createChild("C_DOC_STAN", "1")
				createChild("D_FILL", format("ddmmyyyy", new Date()));
				createChild("SOFTWARE", "DPA");
			}
			with (createChild("DECLARBODY"))
			{
				createChild("HNP", "01");
				createChild("HZ", "1");
				//createChild("TIN", getPar("OOKPO"));
				createChild("HZY", format("yyyy", gd.dat1))
				createChild("HZKV", "");
				createChild("HZM", format("m", gd.dat1))
				createChild("HNAME", getPar("OFIRM"))
				createChild("HNPDV", tforg("CODNDS"));
				createChild("HNSPDV", tforg("FREGIS"));
				
				var bDbExists = false;
				var bCrExists = false;
				var nRow = 0;

				
				if (IsTable("REESTR_CR_NN"))
				{
					var tbl = OpenTable("s", "SELECT * FROM REESTR_CR_NN ORDER BY N2");
					//var tbl = OpenTable("s", "SELECT FINDNUM, MIN(FDATE) as fgdate, SUM(FSUM) as FGSUM, SUM(FNDS) as FGNDS FROM " + strName + " WHERE FSUM<>0 or FNDS<>0"
					// + " GROUP BY FINDNUM, " + sqlYear("FDATE") + ", " + sqlMonth("FDATE") );
					if (tbl)
					{
						for (; !tbl.IsEOF(); tbl.MoveNext())
						{
							bCrExists = true;
							nRow++;
	
							var aAttrRow = {"ROWNUM": nRow};
	
							createChild("T2RXXXXGKOR", getKorr(tbl.getValue("FISCORR"), tbl.getValue("FVID_DOC")), aAttrRow) // Ознака коригування
							createChild("T2RXXXXG1", nRow, aAttrRow);
							createChild("T2RXXXXG2D", format("ddmmyyyy", tbl.getValue("N2")), aAttrRow)
							if (isEmpty(tbl.getValue("HVYP_DATE")))
								createChild("T2RXXXXG3D", format("ddmmyyyy", tbl.getValue("N2")), aAttrRow)
							else
								createChild("T2RXXXXG3D", format("ddmmyyyy", tbl.getValue("HVYP_DATE")), aAttrRow)
							createChild("T2RXXXXG4S", tbl.getValue("N3"), aAttrRow);
							createChild("T2RXXXXG5S", tbl.getValue("HVID_DOC"), aAttrRow) // Ознака типу документа: 1 - податкова накладна; 2 - вантажно-митна декларація; 3 - чек; 4 - інше 
							createChild("T2RXXXXG6S",  tcl("CL", "TXT", 0, tbl.getValue("HORG")), aAttrRow)
							//createChild("T2RXXXXGNREZ", toScrObj(tforg("FISNOTREZID", tbl.getValue("HORG")))? "1": "0", aAttrRow) // Ознака резидентности
							createChild("T2RXXXXG7",tcl("ORG", "CODNDS", tbl.getValue("HORG")), aAttrRow);
							createChild("T2RXXXXG8", format("0.00{0:}", tbl.getValue("N6")), aAttrRow);
							createChild("T2RXXXXG9", format("0.00{0:}", tbl.getValue("N7")), aAttrRow);
							createChild("T2RXXXXG10", format("0.00{0:}", tbl.getValue("N8")), aAttrRow);
							createChild("T2RXXXXG11", format("0.00{0:}", tbl.getValue("N9")), aAttrRow);
							createChild("T2RXXXXG12", format("0.00{0:}", tbl.getValue("N10")), aAttrRow);
							createChild("T2RXXXXG13", format("0.00{0:}", tbl.getValue("N11")), aAttrRow);
							createChild("T2RXXXXG14", format("0.00{0:}", tbl.getValue("N12")), aAttrRow);
							createChild("T2RXXXXG15", format("0.00{0:}", tbl.getValue("N13")), aAttrRow);
							createChild("T2RXXXXG16", format("0.00{0:}", tbl.getValue("N14")), aAttrRow);
						}
					}
				}
				else
				{
					var tbl = OpenTable("s", "SELECT * FROM REESTR_CR");
					//var tbl = OpenTable("s", "SELECT FINDNUM, MIN(FDATE) as fgdate, SUM(FSUM) as FGSUM, SUM(FNDS) as FGNDS FROM " + strName + " WHERE FSUM<>0 or FNDS<>0"
					// + " GROUP BY FINDNUM, " + sqlYear("FDATE") + ", " + sqlMonth("FDATE") );
					if (tbl)
					{
						for (; !tbl.IsEOF(); tbl.MoveNext())
						{
							bCrExists = true;
							nRow++;

							var aAttrRow = {"ROWNUM": nRow};

							createChild("T2RXXXXGKOR", getKorr(tbl.getValue("FISCORR"), tbl.getValue("FVID_DOC")), aAttrRow) // РћР·РЅР°РєР° РєРѕСЂРёРіСѓРІР°РЅРЅСЏ
							createChild("T2RXXXXG1", nRow, aAttrRow);
							createChild("T2RXXXXG2D", format("ddmmyyyy", tbl.getValue("fdoc_dat")), aAttrRow)
							createChild("T2RXXXXG3D", format("ddmmyyyy", tbl.getValue("fNK_dat")), aAttrRow)
							createChild("T2RXXXXG4S", tbl.getValue("fnk_num"), aAttrRow);
							createChild("T2RXXXXG5S", tbl.getValue("ftype"), aAttrRow) // РћР·РЅР°РєР° С‚РёРїСѓ РґРѕРєСѓРјРµРЅС‚Р°: 1 - РїРѕРґР°С‚РєРѕРІР° РЅР°РєР»Р°РґРЅР°; 2 - РІР°РЅС‚Р°Р¶РЅРѕ-РјРёС‚РЅР° РґРµРєР»Р°СЂР°С†С–СЏ; 3 - С‡РµРє; 4 - С–РЅС€Рµ 
							if (!tbl.getValue("forg_txt"))
								createChild("T2RXXXXG6S", tcl("CL", "TXT", 0, tbl.getValue("forg")), aAttrRow)
							else
								createChild("T2RXXXXG6S", tbl.getValue("forg_txt"), aAttrRow)
							createChild("T2RXXXXGNREZ", toScrObj(tbl.getValue("FISNOTREZID"))? "1": "0", aAttrRow) // РћР·РЅР°РєР° СЂРµР·РёРґРµРЅС‚РЅРѕСЃС‚Рё
							createChild("T2RXXXXG7", tbl.getValue("FINDNUM"), aAttrRow);
							createChild("T2RXXXXG8", format("0.00{0:}", tbl.getValue("F_06")), aAttrRow);
							createChild("T2RXXXXG9", format("0.00{0:}", tbl.getValue("F_07")), aAttrRow);
							createChild("T2RXXXXG10", format("0.00{0:}", tbl.getValue("F_08")), aAttrRow);
							createChild("T2RXXXXG11", format("0.00{0:}", tbl.getValue("F_09")), aAttrRow);
							createChild("T2RXXXXG12", format("0.00{0:}", tbl.getValue("F_10")), aAttrRow);
							createChild("T2RXXXXG13", format("0.00{0:}", tbl.getValue("F_11")), aAttrRow);
							createChild("T2RXXXXG14", format("0.00{0:}", tbl.getValue("F_12")), aAttrRow);
							createChild("T2RXXXXG15", format("0.00{0:}", tbl.getValue("F_13")), aAttrRow);
							createChild("T2RXXXXG16", format("0.00{0:}", tbl.getValue("F_14")), aAttrRow);
						}
					}
				}
					
				if (IsTable("REESTR_DB_NV"))
				{
					var nRow = 0;
					var tbl = OpenTable("s", 
						"SELECT * FROM REESTR_DB_NV "
						+ " ORDER BY " + Convert(SqlRight(SqlConCat("'              '","HNOM"),14), "STR")
						);
					//var tbl = OpenTable("s", "SELECT FINDNUM, MIN(FDATE) as fgdate, SUM(FSUM) as FGSUM, SUM(FNDS) as FGNDS FROM " + strName + " WHERE FSUM<>0 or FNDS<>0"
					// + " GROUP BY FINDNUM, " + sqlYear("FDATE") + ", " + sqlMonth("FDATE") );
					if (tbl)
					{
						for (; !tbl.IsEOF(); tbl.MoveNext())
						{
							bDbExists = true;
							nRow++;
	
							var aAttrRow = {"ROWNUM": nRow};
	
							createChild("T1RXXXXGKOR", getKorr(false /*tbl.getValue("FISCORR")*/, tbl.getValue("FVID_DOC")), aAttrRow) // РћР·РЅР°РєР° РєРѕСЂРёРіСѓРІР°РЅРЅСЏ
							createChild("T1RXXXXG1", nRow, aAttrRow);
							createChild("T1RXXXXG2D", format("ddmmyyyy", tbl.getValue("hdat")), aAttrRow)
							createChild("T1RXXXXG3S", tbl.getValue("hnom"), aAttrRow);
							//createChild("T1RXXXXG4S", tbl.getValue("ftype"), aAttrRow) // РћР·РЅР°РєР° С‚РёРїСѓ РґРѕРєСѓРјРµРЅС‚Р°: 1 - РїРѕРґР°С‚РєРѕРІР° РЅР°РєР»Р°РґРЅР°; 2 - РІР°РЅС‚Р°Р¶РЅРѕ-РјРёС‚РЅР° РґРµРєР»Р°СЂР°С†С–СЏ; 3 - С‡РµРє; 4 - С–РЅС€Рµ 
							createChild("T1RXXXXG4S", tbl.getValue("FVID_DOC"), aAttrRow) // РћР·РЅР°РєР° С‚РёРїСѓ РґРѕРєСѓРјРµРЅС‚Р°: 1 - РїРѕРґР°С‚РєРѕРІР° РЅР°РєР»Р°РґРЅР°; 2 - РІР°РЅС‚Р°Р¶РЅРѕ-РјРёС‚РЅР° РґРµРєР»Р°СЂР°С†С–СЏ; 3 - С‡РµРє; 4 - С–РЅС€Рµ
							//if (!tbl.getValue("forg_txt"))
								createChild("T1RXXXXG5S", tcl("CL", "TXT", 0, tbl.getValue("horg")), aAttrRow)
							//else
							//	createChild("T1RXXXXG5S", tbl.getValue("forg_txt"), aAttrRow)
							createChild("T1RXXXXGNREZ", "1" /* toScrObj(tbl.getValue("FISNOTREZID"))? "1": "0"*/, aAttrRow) // РћР·РЅР°РєР° СЂРµР·РёРґРµРЅС‚РЅРѕСЃС‚Рё
							
							if(tforg("PLATNDS", tbl.getValue("horg")))
								createChild("T1RXXXXG6", tcl("ORG", "CODNDS", tbl.getValue("horg")), aAttrRow);
							//createChild("T1RXXXXG6", tbl.getValue("FINDNUM"), aAttrRow);
								
							
							createChild("T1RXXXXG7", format("0.00{0:}", tbl.getValue("fsum")), aAttrRow);
							createChild("T1RXXXXG8", format("0.00{0:}", tbl.getValue("fsum_20")), aAttrRow);
							createChild("T1RXXXXG9", format("0.00{0:}", tbl.getValue("fnds")), aAttrRow);
							createChild("T1RXXXXG10", format("0.00{0:}", tbl.getValue("fsum_0")), aAttrRow);
							createChild("T1RXXXXG11", format("0.00{0:}", tbl.getValue("fsum_zv")), aAttrRow);
							createChild("T1RXXXXG12", format("0.00{0:}", tbl.getValue("fsum_exp")), aAttrRow);
						}
					}
				}
				else
				{
					var nRow = 0;
					var tbl = OpenTable("s", "SELECT * FROM REESTR_DB WHERE fid_doc<>0 ORDER BY F_01");
					//var tbl = OpenTable("s", "SELECT FINDNUM, MIN(FDATE) as fgdate, SUM(FSUM) as FGSUM, SUM(FNDS) as FGNDS FROM " + strName + " WHERE FSUM<>0 or FNDS<>0"
					// + " GROUP BY FINDNUM, " + sqlYear("FDATE") + ", " + sqlMonth("FDATE") );
					if (tbl)
					{
						for (; !tbl.IsEOF(); tbl.MoveNext())
						{
							bDbExists = true;
							nRow++;
	
							var aAttrRow = {"ROWNUM": nRow};
	
							createChild("T1RXXXXGKOR", getKorr(tbl.getValue("FISCORR"), tbl.getValue("FVID_DOC")), aAttrRow) // РћР·РЅР°РєР° РєРѕСЂРёРіСѓРІР°РЅРЅСЏ
							createChild("T1RXXXXG1", nRow, aAttrRow);
							createChild("T1RXXXXG2D", format("ddmmyyyy", tbl.getValue("fnk_dat")), aAttrRow)
							createChild("T1RXXXXG3S", tbl.getValue("fnk_num"), aAttrRow);
							//createChild("T1RXXXXG4S", tbl.getValue("ftype"), aAttrRow) // РћР·РЅР°РєР° С‚РёРїСѓ РґРѕРєСѓРјРµРЅС‚Р°: 1 - РїРѕРґР°С‚РєРѕРІР° РЅР°РєР»Р°РґРЅР°; 2 - РІР°РЅС‚Р°Р¶РЅРѕ-РјРёС‚РЅР° РґРµРєР»Р°СЂР°С†С–СЏ; 3 - С‡РµРє; 4 - С–РЅС€Рµ 
							var vid_doc = tbl.getValue("FVID_DOC");
							if (!tforg("PLATNDS", tbl.getValue("forg")) && vid_doc=="ПН")
								createChild("T1RXXXXG4S", "ПН02", aAttrRow)
							else
								createChild("T1RXXXXG4S", tbl.getValue("FVID_DOC"), aAttrRow) // РћР·РЅР°РєР° С‚РёРїСѓ РґРѕРєСѓРјРµРЅС‚Р°: 1 - РїРѕРґР°С‚РєРѕРІР° РЅР°РєР»Р°РґРЅР°; 2 - РІР°РЅС‚Р°Р¶РЅРѕ-РјРёС‚РЅР° РґРµРєР»Р°СЂР°С†С–СЏ; 3 - С‡РµРє; 4 - С–РЅС€Рµ
							
							if (!tbl.getValue("forg_txt"))
								createChild("T1RXXXXG5S", tcl("CL", "TXT", 0, tbl.getValue("forg")), aAttrRow)
							else
								createChild("T1RXXXXG5S", tbl.getValue("forg_txt"), aAttrRow)
							createChild("T1RXXXXGNREZ", toScrObj(tbl.getValue("FISNOTREZID"))? "1": "0", aAttrRow) // РћР·РЅР°РєР° СЂРµР·РёРґРµРЅС‚РЅРѕСЃС‚Рё
							
							if(tforg("PLATNDS", tbl.getValue("forg")))
								createChild("T1RXXXXG6", tcl("ORG", "CODNDS", tbl.getValue("forg")), aAttrRow);
							else
								createChild("T1RXXXXG6", "0", aAttrRow);
							//createChild("T1RXXXXG6", tbl.getValue("FINDNUM"), aAttrRow);
								
							
							createChild("T1RXXXXG7", format("0.00{0:}", tbl.getValue("F_06")), aAttrRow);
							createChild("T1RXXXXG8", format("0.00{0:}", tbl.getValue("F_07")), aAttrRow);
							createChild("T1RXXXXG9", format("0.00{0:}", tbl.getValue("F_08")), aAttrRow);
							createChild("T1RXXXXG10", format("0.00{0:}", tbl.getValue("F_09")), aAttrRow);
							createChild("T1RXXXXG11", format("0.00{0:}", tbl.getValue("F_10")), aAttrRow);
							createChild("T1RXXXXG12", format("0.00{0:}", tbl.getValue("F_11")), aAttrRow);
						}
					}
				}
				
				createChild("HBOS", tcontacts(CURRENT_ORG, "BOSS"));
				createChild("HKBOS", tcontacts(CURRENT_ORG, "BOSS", "FTAXNUM"));
				createChild("HBUH", tcontacts(CURRENT_ORG, "BUCH"));
				createChild("HKBUH", tcontacts(CURRENT_ORG, "BUCH", "FTAXNUM"));
				
				if (bDbExists == false && bCrExists == false)
					alert("Нет данных для выгрузки в XML");
				else if (bDbExists == false)
					alert("Нет данных по налоговым обязательствам для выгрузки в XML");
				else if (bCrExists == false)
					alert("Нет данных по налоговому кредиту для выгрузки в XML");
			}
		}
	}

	var xmlName = getPar("EXPDIR");
	xmlName += (getPar("EXPDIR").right(1) == "\\" || getPar("EXPDIR").right(1) == "/" ? "" : "/");
	xmlName += "reestr.xml";
	xml.save(xmlName, "windows-1251");
	alert("Выгрузка окончена - " + xmlName);
}

function getKorr(FISCORR, FVID_DOC)
{
	if (Boolean(FISCORR))
		return true;
	if (String(FVID_DOC)=="РК")
		return true;
}

function getVidNo(txt)
{
	switch(String(txt).toUpperCase())
	{
	case "ПН":	return 1;
	case "ПНУ": return 2;
	case "РК": return 6;
	case "РКУ": return 7;
	case "ВМД": return 2;
	case "ВМДУ": return 8;
	case "ПП": return 9;
	case "ППУ": return 10;
	case "ЗЦ": return 11;
	case "ЗЦУ": return 12;
	}
	
	return 1;


}
function ExportReestrNalKredit()
{
	var gd = new DpGetDat("d");
	if (gd.escape != false)
		return;

	var xml = new DpXMLDOMDocument();
	with(xml)
	{
		with( createChild("DECLAR"))
		{
			setAttribute("xmlns:xsi", "http://www.w3.org/2001/XMLSchema-instance");
			setAttribute("xsi:noNamespaceSchemaLocation", "J1201503.xsd");

			with (createChild("DECLARHEAD"))
			{
				createChild("TIN", getPar("OOKPO"));
				createChild("C_DOC", "J12");
				createChild("C_DOC_SUB", "015");
				createChild("C_DOC_VER", "3");
				createChild("C_DOC_TYPE", "0");
				createChild("C_DOC_CNT", "1");
				createChild("C_REG", "23");
				createChild("C_RAJ", "1");                  //Район
				createChild("PERIOD_MONTH", format("m",gd.dat1))
				createChild("PERIOD_TYPE", "1");
				createChild("PERIOD_YEAR", format("yyyy", gd.dat1))
				createChild("D_FILL", format("ddmmyyyy", new Date()));
				createChild("SOFTWARE", "DPA");
			}
			with (createChild("DECLARBODY"))
			{
				//createChild("TIN", getPar("OOKPO"));
				createChild("HZY", format("yyyy", gd.dat1))
				createChild("HZKV", "");
				createChild("HZM", format("m", gd.dat1))
				
				var bDbExists = false;
				var bCrExists = false;
				var nRow = 0;
				strName = "DODATOK5_DB";
				
				var tbl = OpenTable("s", "SELECT  * FROM REESTR_CR_NAL_KREDIT");
				if (tbl)
				{
					for (; !tbl.IsEOF(); tbl.MoveNext())
					{
						bCrExists = true;
						nRow++;

						var aAttrRow = {"ROWNUM": nRow};

						createChild("T1RXXXXGKOR", "0", aAttrRow) // Ознака коригування
						createChild("T1RXXXXG1", nRow, aAttrRow);
						createChild("T1RXXXXG2D", format("ddmmyyyy", tbl.getValue("fdoc_dat")), aAttrRow)
						createChild("T1RXXXXG3D", format("ddmmyyyy", tbl.getValue("fdoc_dat")), aAttrRow)
						createChild("T1RXXXXG4S", "", aAttrRow);
						createChild("T1RXXXXG5S", "ПНР", aAttrRow) // Ознака типу документа: 1 - податкова накладна; 2 - вантажно-митна декларація; 3 - чек; 4 - інше
						createChild("T1RXXXXG6S", tcl("CL", "TXT", 0, tbl.getValue("forg")), aAttrRow)
						createChild("T1RXXXXGNREZ", toScrObj(tbl.getValue("FISNOTREZID"))? "1": "0", aAttrRow) // Ознака резидентности
						createChild("T1RXXXXG7", tbl.getValue("FINDNUM"), aAttrRow);
						createChild("T1RXXXXG8", round(tbl.getValue("F_06"), 2), aAttrRow);
						createChild("T1RXXXXG9", round(tbl.getValue("F_07"), 2), aAttrRow);
						createChild("T1RXXXXG10", round(tbl.getValue("F_08"), 2), aAttrRow);
						createChild("T1RXXXXG11", round(tbl.getValue("F_09"), 2), aAttrRow);
						createChild("T1RXXXXG12", round(tbl.getValue("F_10"), 2), aAttrRow);
						createChild("T1RXXXXG13", round(tbl.getValue("F_11"), 2), aAttrRow);
						createChild("T1RXXXXG14", round(tbl.getValue("F_12"), 2), aAttrRow);
						createChild("T1RXXXXG15", round(tbl.getValue("F_13"), 2), aAttrRow);
					}
				}
				
				if (bCrExists == false)
					alert("Нет данных по перераспределению налогового кредита для выгрузки в XML");
			}
		}
	}

	var xmlName = getPar("EXPDIR");
	xmlName += (getPar("EXPDIR").right(1) == "\\" || getPar("EXPDIR").right(1) == "/" ? "" : "/");
	xmlName += "reestr_nal_kredit.xml";
	xml.save(xmlName, "windows-1251");
	alert("Выгрузка окончена - " + xmlName);
}

function ExportStat1PV()
{
	var gd=new DpGetDat(new Array("r"));
	if (gd.escape != false)
		return;

	var xml = new DpXMLDOMDocument();
	with(xml)
	{
		with( createChild("DECLAR"))
		{
			setAttribute("xmlns:xsi", "http://www.w3.org/2001/XMLSchema-instance");
			setAttribute("xsi:noNamespaceSchemaLocation", "s0301007.xsd");

			with (createChild("DECLARHEAD"))
			{
				createChild("TIN", getPar("OOKPO"));
				createChild("C_DOC", "s03");
				createChild("C_DOC_SUB", "010");
				createChild("C_DOC_VER", "7");
				createChild("C_DOC_TYPE", "0");
				createChild("C_DOC_CNT", "1");
				createChild("C_REG", "23");
				createChild("C_RAJ", "1");                  //Р Р°Р№РѕРЅ
				createChild("PERIOD_MONTH", format("m",gd.dat1))
				createChild("PERIOD_TYPE", "1");
				createChild("PERIOD_YEAR", format("yyyy", gd.dat1))
				createChild("D_FILL", format("ddmmyyyy", new Date()));
				createChild("SOFTWARE", "DPA");
			}
			with (createChild("DECLARBODY"))
			{
				createChild("HTIN", getPar("OOKPO"));
				createChild("HNAME", getPar("OFIRM"));
				
				/*
				var nRow = 0;
				strName = "RRO_CASS";
				var tbl = OpenTable("s", "SELECT * FROM " + strName);
				if (!tbl)
				{
					alert("РќРµС‚ РґР°РЅРЅС‹С… РґР»СЏ РІС‹РіСЂСѓР·РєРё РІ XML");
					return;
				}
				
				for (; !tbl.IsEOF(); tbl.MoveNext())
				{
					nRow++;

					var aAttrRow = {"ROWNUM": nRow};
					createChild("RXXXXG2S", tbl.getValue("RXXXXG2S"), aAttrRow);
					createChild("RXXXXG3S", tbl.getValue("RXXXXG3S"), aAttrRow);
					createChild("RXXXXG4", tbl.getValue("RXXXXG4"), aAttrRow);
					createChild("RXXXXG5", tbl.getValue("RXXXXG5"), aAttrRow);
					createChild("RXXXXG6", tbl.getValue("RXXXXG6"), aAttrRow);
					createChild("RXXXXG7", tbl.getValue("RXXXXG7"), aAttrRow);
				}
				*/
			}
		}
	}

	var xmlName = getPar("EXPDIR");
	xmlName += (getPar("EXPDIR").right(1) == "\\" || getPar("EXPDIR").right(1) == "/" ? "" : "\\");
	xmlName += "stat_1PV.xml";
	xml.save(xmlName, "windows-1251");
	alert("Р’С‹РіСЂСѓР·РєР° РѕРєРѕРЅС‡РµРЅР° - " + xmlName);
}

function importDodatok8Table()
{
	var arrData = new Array();
	
	var sStartDir = userDirectory();		
	var sLastFile = String(ReadParEx("LASTIMPORTFILE"));			
	
	if (sLastFile)
	{
		var oFile = new java.io.File(sLastFile);			
		var sStartDir = String(oFile.getParent()); 
	}
	var sFileName = BrowseForFile("*.xls", "Файлы MS Excel *.xls", sStartDir);
	if(!sFileName)
		return;
			
	WriteParEx("LASTIMPORTFILE", sFileName);

	var xlsdoc = lpProxy.openExcelWorkbook(sFileName);
	if (xlsdoc==null)
	{
		alert(ru("Ошибка открытия документа Excel!","Помилка відкриття документа Excel!"));
		return;
	}

	//считываем количество строк на первом листе
	var nY	= xlsdoc.getSheet(xlsdoc.getSheetName(0)).getLastRowNum();
	var nCount = 0;
	
	var nRow = 0;
	var nExcelRow = 0;
	while (nExcelRow <=nY)
	{
		var FINDNUM = "";
		var FTXT = "";
		var FSUM = 0;
		var FNDS = 0;
		var FDAT = 0;
		var FNUM = "";
		// считываем данные если ячейка первого столбца явл. числовым типом
		if(xlsdoc.getSheet(xlsdoc.getSheetName(0)).getRow(nExcelRow)!=null && 
			xlsdoc.getSheet(xlsdoc.getSheetName(0)).getRow(nExcelRow).getCell(0)!=null &&
			(xlsdoc.getSheet(xlsdoc.getSheetName(0)).getRow(nExcelRow).getCell(0).getCellType()==0 ||
			 	xlsdoc.getSheet(xlsdoc.getSheetName(0)).getRow(nExcelRow).getCell(0).getCellType()==1))
		{
			if(xlsdoc.getSheet(xlsdoc.getSheetName(0)).getRow(nExcelRow).getCell(6).getCellType()==0)
				FINDNUM = String(xlsdoc.getSheet(xlsdoc.getSheetName(0)).getRow(nExcelRow).getCell(6).getNumericCellValue());
			else if (xlsdoc.getSheet(xlsdoc.getSheetName(0)).getRow(nExcelRow).getCell(6).getCellType()==1)
				FINDNUM = String(xlsdoc.getSheet(xlsdoc.getSheetName(0)).getRow(nExcelRow).getCell(6).getStringCellValue());
			if(xlsdoc.getSheet(xlsdoc.getSheetName(0)).getRow(nExcelRow).getCell(2).getCellType()==0)
				FDAT = new Date(xlsdoc.getSheet(xlsdoc.getSheetName(0)).getRow(nExcelRow).getCell(2).getDateCellValue());
			if(xlsdoc.getSheet(xlsdoc.getSheetName(0)).getRow(nExcelRow).getCell(8).getCellType()==0)
				FSUM = String(xlsdoc.getSheet(xlsdoc.getSheetName(0)).getRow(nExcelRow).getCell(8).getNumericCellValue());
			if(xlsdoc.getSheet(xlsdoc.getSheetName(0)).getRow(nExcelRow).getCell(9).getCellType()==0)
				FNDS = String(xlsdoc.getSheet(xlsdoc.getSheetName(0)).getRow(nExcelRow).getCell(9).getNumericCellValue());
			if (xlsdoc.getSheet(xlsdoc.getSheetName(0)).getRow(nExcelRow).getCell(5).getCellType()==1)
				FTXT = String(xlsdoc.getSheet(xlsdoc.getSheetName(0)).getRow(nExcelRow).getCell(5).getStringCellValue());
			if(xlsdoc.getSheet(xlsdoc.getSheetName(0)).getRow(nExcelRow).getCell(3).getCellType()==0)
				FNUM = String(xlsdoc.getSheet(xlsdoc.getSheetName(0)).getRow(nExcelRow).getCell(3).getNumericCellValue());
			else if (xlsdoc.getSheet(xlsdoc.getSheetName(0)).getRow(nExcelRow).getCell(3).getCellType()==1)
				FNUM = String(xlsdoc.getSheet(xlsdoc.getSheetName(0)).getRow(nExcelRow).getCell(3).getStringCellValue());
		}
		
		if (FDAT != 0 && FDAT.getFullYear() > 1950)
		{
			arrData[nCount] = new Array();
			arrData[nCount]["FINDNUM"] = FINDNUM;
			arrData[nCount]["FSUM"] = Number(FSUM);
			arrData[nCount]["FNDS"] = Number(FNDS);
			arrData[nCount]["FDAT"] = FDAT;
			arrData[nCount]["FTXT"] = FTXT;
			arrData[nCount]["FNUM"] = FNUM;
        	nCount++;
		}

		nExcelRow++;
	}
	
	return arrData;
}

Load();